lambda = -1000 + 1i*pi;

% Define functions
h = linspace(0, 0.005, 200);
f_1 = @(h) 1 - abs(1 + h*lambda + 1/2*(h*lambda).^2);
f_2 = @(h) 1 - abs(1 + h*lambda + 1/2*(h*lambda).^2 + 1/6*(h*lambda).^3 + 1/24*(h*lambda).^4);
f_3 = @(h) 1 - abs((2 + h*lambda)./(2-h*lambda));

% Plot functions
figure
subplot(2, 2, 1); plot(h, f_1(h)); grid on
subplot(2, 2, 2); plot(h, f_2(h)); grid on
h = linspace(0, 5, 200);
subplot(2, 2, 3); plot(h, f_3(h)); grid on

% Find zeros
zero_1 = fsolve(f_1, 2);
zero_2 = fsolve(f_2, 0.005);
zero_3 = fsolve(f_3, 0.0000005);

fprintf('Null bei x = %.4f\n', zero_1);
fprintf('Null bei x = %.4f\n', zero_2);
fprintf('Null bei x = %.4f\n', zero_3);

% Plot zeros
subplot(2, 2, 1); hold on; plot(zero_1, 0, '.r', 'Markersize', 10);
subplot(2, 2, 2); hold on; plot(zero_2, 0, '.r', 'Markersize', 10);
subplot(2, 2, 3); hold on; plot(zero_3, 0, '.r', 'Markersize', 10); xlim([0 5]);
