% Zeichne Stabilitaetsgebiete

% ein paar Parameter
xmin = -4.;
xmax = +2.;
Nx = 300;
ymin = -3.;
ymax = +3.;
Ny = 300;

% explizites Euler Verfahren
g = @(z) 1. + z;
draw_stabfunc(g,xmin,xmax,Nx,ymin,ymax,Ny);
title('Stabilitaetsgebiet (Expliziter Euler)');
% print('stabgeb_euler_explizit.png','-dpng')
disp('Hit enter to proceed...');
pause;

% implizit Euler Verfahren
g = @(z) 1./(1. - z);
draw_stabfunc(g,xmin,xmax,Nx,ymin,ymax,Ny)
title('Stabilitaetsgebiet (Impliziter Euler)');
% print('stabgeb_euler_implizit.png','-dpng')
disp('Hit enter to proceed...');
pause;

% Heun Verfahren
g = @(z) 1. + z + 0.5*z.^2;
draw_stabfunc(g,xmin,xmax,Nx,ymin,ymax,Ny)
title('Stabilitaetsgebiet (Heun)');
% print('stabgeb_heun.png','-dpng')
disp('Hit enter to proceed...');
pause;

% Klassisches Runge-Kutta Verfahren (aka RK4)
g = @(z) 1. + z + 0.5*z.^2 + z.^3/6. + z.^4/24.;
draw_stabfunc(g,xmin,xmax,Nx,ymin,ymax,Ny)
title('Stabilitaetsgebiet (RK4)');
% print('stabgeb_rk4.png','-dpng')
disp('Hit enter to proceed...');
pause;

% Implizite Mittelpunktsregel
g = @(z) (1. + 0.5*z)./(1. - 0.5*z);
draw_stabfunc(g,xmin,xmax,Nx,ymin,ymax,Ny)
title('Stabilitaetsgebiet (Implizite Mittelpunktsregel)');
% print('stabgeb_implizite_mittelpunktsregel.png','-dpng')
